#ifndef I0MMTOPOBARCHART_H
#define I0MMTOPOBARCHART_H

#include <qwt_plot.h>
#include <qwt_scale_draw.h>
#include <QList>
#include <cudata.h>
#include <qwt_plot_marker.h>

#include "i0mapmontopoobjfilter.h"

class QwtPlotMultiBarChart;

class LogTransform : public QwtLogTransform {
public:
    LogTransform() : QwtLogTransform() { printf("LOG TRANSFORM\n"); }
    // QwtTransform interface
public:
    double bounded(double v) const;
};

class NamesAxisDraw : public QwtScaleDraw {
public:
    virtual QwtText label(double value) const;

    void setNames(const QStringList &nl) { m_names = nl; }
    QStringList names() const { return m_names; }
    int size() const { return m_names.size(); }

private:
    QStringList m_names;
};

class I0MMTopoBarChart : public QwtPlot
{
    Q_OBJECT
public:
    explicit I0MMTopoBarChart(QWidget *parent = nullptr);
    bool isEmpty() const;
    bool stackedMode() const;
    QVector<int> lambdas() const;
    QwtPlotItem *findItem(const int rtti) const;

public slots:
    void update(const QList<CuData> &);
    void clear();
    void setNames(const QStringList& names);
    void setLabels(const QStringList& ls);
    void enableLogScale(bool en);
    void setLambdas(const QVector<int> lidxs);

signals:

private slots:
    void m_onBarsModeChanged(int mode);

private:
    void m_error(const std::string& err);
    void m_update_bars(const QVector<int> &lambdas);

private:
    QwtPlotMultiBarChart *m_barchart;
    QVector<int> m_cur_lambdas;
    QMap<int, QString> m_colormap;
    int m_lambda_data_size;
    QList<CuData> m_cur_data;
};

#endif // I0MMTOPOBARCHART_H
